# encoding: utf-8
#
# Un clasificador binario realizado
# con una máquina de soporte vectorial lineal
#
# Fraga 20.2.2020
#
import numpy as np
from sklearn import datasets
from sklearn import model_selection
import cv2 
from sklearn import metrics
import matplotlib.pyplot as plt

iris = datasets.load_iris( )

# a = dir( iris )
# print( a )
# ['DESCR', 'data', 'feature_names', 'filename', 'target', 'target_names']

# Son tres clase, entonces tomamos las primeras
# dos para crear un problema de clasifición binario

vindex = iris.target != 2
datos1 = iris.data[ vindex ].astype( np.float32 )
target = iris.target[ vindex ].astype( np.int )
# target = target * 2 - 1
# Las equiquetas 0, quedan -1
# Las equiquetas 1, quedan  1

# Usamos las dos primeras columnas,
# las dimensiones de los sépalos
datos = datos1[ :, 0:2 ]

# Ya tenemos nuestro problema de clasificación binario
# Separamos los datos en dos conjuntos:
# datos de entrenamiento y
# datos de prueba
Xentrena, Xprueba, yentrena, yprueba = model_selection.train_test_split( datos, target, test_size = 0.1, random_state = 10 )

# print( type( Xentrena), type( Xprueba), type( yentrena ), type( yprueba ) )
# print( Xentrena.shape, Xprueba.shape, yentrena.shape, yprueba.shape )

svmLineal = cv2.ml.SVM_create( )
svmLineal.setKernel( cv2.ml.SVM_LINEAR )

svmLineal.train( Xentrena, cv2.ml.ROW_SAMPLE, yentrena )

S = svmLineal.getSupportVectors( )	
print( S.shape )
print( S )

retval, alpha, svidx = svmLineal.getDecisionFunction(0 )
print( "r", retval )
print( alpha )
print( svidx )


# retval = svmLineal.getCoef0( )
# print( retval )

# modelo = regLog.get_learnt_thetas()
# print( modelo )

ret, ypredichas = svmLineal.predict( Xentrena )
exactitud = metrics.accuracy_score( yentrena, ypredichas )
print( "Entrenamiento:", exactitud )


ret, ypredichas = svmLineal.predict( Xprueba )
precision = metrics.accuracy_score( yprueba, ypredichas )
print( "Prueba:", precision )


a=S[0,0] 
b=S[0,1]
c = retval 
print( a, b, c )
vx = np.linspace(4.0, 7.0, 50)
vy = y = (c - a*vx)/b 

plt.subplot( 1,2,1 )
plt.scatter( Xentrena[:,0], Xentrena[:,1], c=yentrena )
plt.plot( vx, vy )
plt.subplot( 1,2,2 )
plt.scatter( Xprueba[:,0], Xprueba[:,1], c=yprueba )
plt.plot( vx, vy )
plt.show()
